type employee = {name:string ;  married:bool; age:int}

let employee_of_tuple (t:string*int*bool) =
  let (n,a,m) = t in
  {name = n; married=m; age=a}

let tuple_of_employee (e:employee) =
  let (n,a,m) = (e.name,e.age,e.married) in
  (n,a,m)



let why = "OCaml uses the last declared record with a field called name."
let how = "add a type specifier to the signature"
type employer = {name:string; est_year:int }
let get_name (e:employee) = e.name
let g : employee = employee_of_tuple ("Greg", 12, true)
let _ = print_string (get_name g)

let rec length (l:'a list) : int =
  match l with
  | [] -> 0
  | h::t -> 1 + (length t)

let rev l =
  let rec rev' l a =
    match l with
    | [] -> a
    | h::t -> rev' t (h::a)
  in
  rev' l []

let rec rmk k l =
  match l with
  | [] -> []
  | h::t ->
    if k = 0 then rmk (k-1) t
    else h :: (rmk (k-1) t)

let min_option x y =
  match x, y with
  | None, None -> None
  | Some x', None -> Some x'
  | None, Some y' -> Some y'
  | Some x', Some y' -> Some (min x' y')

let max_option x y =
  match x, y with
  | None, None -> None
  | Some x', None -> Some x'
  | None, Some y' -> Some y'
  | Some x', Some y' -> Some (max x' y')

let get_option (x:int option option option option) : int option =
  match x with
  | Some (Some (Some (Some x))) -> Some x
  | _ -> None

let and_option x y =
  match x, y with
  | None, None -> None
  | Some x', None -> Some x'
  | None, Some y' -> Some y'
  | Some x', Some y' -> Some (x' && y')

let or_option x y =
  match x, y with
  | None, None -> None
  | Some x', None -> Some x'
  | None, Some y' -> Some y'
  | Some x', Some y' -> Some (x' || y')

let calc_option (f: 'a->'a->'a) (x: 'a option) (y: 'a option) : 'a option =
  match x, y with
  | None, None -> None
  | Some x', None -> Some x'
  | None, Some y' -> Some y'
  | Some x', Some y' -> Some (f x' y')

let min_option2 x y =
  calc_option min x y

let max_option2 x y =
  calc_option max x y

let final l =
  let rec aux l p =
    match l with
    | [] -> p
    | h::t -> aux t h
  in
  match l with
  | [] -> None
  | h::t -> Some (aux t h)
